Prerequisites
==============

You will need the Coq proof assistant v8.4 (Coq >= 8.4pl3, < 8.5), along with the following libraries:

1. Ssreflect 1.5 and MathComp 1.5 (for Coq 8.4)

  - http://www.msr-inria.inria.fr/projects/mathematical-components/
  - http://ssr.msr-inria.inria.fr/FTP/ssreflect-1.5.tar.gz
  - http://ssr.msr-inria.inria.fr/FTP/mathcomp-1.5.tar.gz

2. Coquelicot 2.1.0

  - https://gforge.inria.fr/frs/download.php/file/34663/coquelicot-2.1.0.tar.gz

3. Multinomials-ssr (in mpoly/)

  - https://github.com/strub/multinomials-ssr

4. Extra mathcomp  (in ssreflect/)

  - cauchyreals.v  ssrcomplex.v  polyorder.v  polyrcf.v  realalg.v

Development
============

1. Common Coq files for the proof of the trancendence of Pi and e:

  - Rstruct.v : the Coq Reals compatible with MathComp
  - Cstruct.v : complex numbers compatible with MathComp (different  from Coquelicot's complex numbers)
  - Canalysis.v : bridge from our complex numbers to Coquelicot
  - mpolytrans.v : the "common theorem" infrastructure and proof.

2. Coq files for the proof of the trancendence of Pi:

  - trans_pi.v

3. Coq files for the trancendence of e:

  - trans_e.v

Configuring and Compiling
==========================

You can install Coq and all the required Coq libraries via opam:

    $> opam repository add coq-released https://coq.inria.fr/opam/released
    $> opam repository add coq-extra-dev https://coq.inria.fr/opam/extra-dev
    $> opam install coq.8.4.6 coq:math-comp.1.5.0 coq:coquelicot.2.1.0

We provide a tentative script to install OCaml/Coq and all the needed
Coq libraries. All the binaries are installed in $PWD/_tools and
should not interfere with any existing OCaml/opam/Coq installations.

*WARNING*: This script downloads/executes remote resources.

    $> make toolchain

Once all the dependencies are installed, you should just have to type:

    $> make

or, if using [make toolchain]:

    $> make build-via-toolchain

Do not mix the two build systems without typing `make clean` when
switching from one to another.
